searchData={"items":[{"type":"module","title":"Ex4j","doc":"Combine the power of Ecto with the Bolt protocol + an elegant DSL for Neo4J databases.","ref":"Ex4j.html"},{"type":"module","title":"Settings - Ex4j","doc":"Add the dependency:\n\n    def deps do\n      [\n        {:ex4j, \"~> 0.1.0\"}\n      ]\n    end\n\n   Add the configuration:\n\n    config :ex4j, Bolt,\n      url: \"bolt://localhost:7687\",\n      basic_auth: [username: \"neo4j\", password: \"zEb0zryxK62NNRXKWxJKd7qeEFkO3mLIgcGwuUA4lvg\"],\n      pool_size: 10,\n      ssl: false","ref":"Ex4j.html#module-settings"},{"type":"module","title":"Examples - Ex4j","doc":"defmodule Node.User do\n      use Ex4j.Node\n\n      graph do\n        field(:name, :string)\n        field(:age, :integer)\n        field(:email, :string)\n      end\n    end\n\n    defmodule Node.Has do\n      use Ex4j.Node\n\n      graph do\n        field(:date, :utc_datetime)\n      end\n    end\n\n    defmodule Node.Comment do\n      use Ex4j.Node\n\n      graph do\n        field(:content, :string)\n      end\n    end\n\n    defmodule App do\n      use Ex4j.Cypher\n\n      alias Node.{User, Has, Comment}\n\n      def execute do\n        User\n        |> match(as: :user)\n        |> vertex(Comment, as: :comment)\n        |> edge(Has, as: :has, from: :user, to: :comment, type: :out)\n        |> where(:user, \"user.name = 'Tiago' OR user.age IN [1,2,3]\")\n        |> where(:comment, \"comment.content CONTAINS 'Article'\")\n        |> where(:has, \"has.date > date('2019-09-30')\")\n        |> return(:user)\n        |> return(:has)\n        |> return(:comment)\n        |> run()\n      end\n    end","ref":"Ex4j.html#module-examples"},{"type":"module","title":"Cypher - Ex4j","doc":"MATCH (user:User WHERE user.name = 'Tiago' OR user.age IN [1,2,3])-[has:Has WHERE has.date > date('2019-09-30')]->(comment:Comment WHERE comment.content CONTAINS 'Article')\n    RETURN user, has, comment","ref":"Ex4j.html#module-cypher"},{"type":"module","title":"Ex4j.Cypher","doc":"DSL to turn elixir code into Cypher Language.","ref":"Ex4j.Cypher.html"},{"type":"function","title":"Ex4j.Cypher.cypher/1","doc":"Returns the Cypher query.","ref":"Ex4j.Cypher.html#cypher/1"},{"type":"function","title":"Parameters - Ex4j.Cypher.cypher/1","doc":"- query: Either the dynamic query or a string cypher query","ref":"Ex4j.Cypher.html#cypher/1-parameters"},{"type":"function","title":"Examples - Ex4j.Cypher.cypher/1","doc":"iex> query = match(User, as: :user)\n    iex> query = return(query, :user)\n    iex> cypher(query)\n    \"MATCH (user:User) RETURN user\"\n\n    iex> cypher(\"MATCH (user:User) RETURN user\")\n    \"MATCH (user:User) RETURN user\"","ref":"Ex4j.Cypher.html#cypher/1-examples"},{"type":"function","title":"Ex4j.Cypher.edge/3","doc":"Creates an EDGE.","ref":"Ex4j.Cypher.html#edge/3"},{"type":"function","title":"Parameters - Ex4j.Cypher.edge/3","doc":"- query: The previous query\n  - module: The name of the Node\n  - as: The alias of the Node\n  - from: Start point\n  - to: End point\n  - type:\n    - :out (->)\n    - :in  (<-)\n    - :any (-)","ref":"Ex4j.Cypher.html#edge/3-parameters"},{"type":"function","title":"Examples - Ex4j.Cypher.edge/3","doc":"iex> query = match(Node.User, as: :user)\n    iex> query = vertex(query, Node.Comment, as: :comment)\n    iex> query = edge(query, HAS, as: :h, from: :user, to: :comment, type: :any)\n    iex> query = where(query, :user, \"user.name = 'Tiago'\"])\n    iex> query = where(query, :h, \"h.value = 42\")\n    iex> return(query, :comment, [:text])\n    %{\n      match: %{user: \"User\"},\n      vertex: %{comment: \"Comment\"},\n      where: %{\n        user: \"user.name = 'Tiago'\",\n        h: \"h.value = 42\"\n      },\n      edge: %{\n        user: %{module: HAS, type: :any, to: :comment, label: :h}\n      },\n      return: %{comment: [:text]}\n    }","ref":"Ex4j.Cypher.html#edge/3-examples"},{"type":"function","title":"Cypher - Ex4j.Cypher.edge/3","doc":"MATCH (user:User WHERE user.name = 'Tiago')-[h:HAS WHERE h.value = 42]-(comment:Comment)\n    RETURN comment.text","ref":"Ex4j.Cypher.html#edge/3-cypher"},{"type":"function","title":"Ex4j.Cypher.limit/2","doc":"Creates a LIMIT clause.","ref":"Ex4j.Cypher.html#limit/2"},{"type":"function","title":"Parameters - Ex4j.Cypher.limit/2","doc":"- query: The previous query\n  - limit: The limit value","ref":"Ex4j.Cypher.html#limit/2-parameters"},{"type":"function","title":"Examples - Ex4j.Cypher.limit/2","doc":"iex> query = match(User, as: :user)\n    iex> query = return(query, :user)\n    iex> limit(query, 10)\n    %{return: %{user: []}, match: %{user: \"User\"}, limit: 10}","ref":"Ex4j.Cypher.html#limit/2-examples"},{"type":"function","title":"Cypher - Ex4j.Cypher.limit/2","doc":"MATCH(user:User)\n    RETURN user\n    LIMIT 10","ref":"Ex4j.Cypher.html#limit/2-cypher"},{"type":"function","title":"Ex4j.Cypher.match/2","doc":"Creates a MATCH clause.","ref":"Ex4j.Cypher.html#match/2"},{"type":"function","title":"Parameters - Ex4j.Cypher.match/2","doc":"- module: The name of the Node\n  - as: The alias of the Node","ref":"Ex4j.Cypher.html#match/2-parameters"},{"type":"function","title":"Examples - Ex4j.Cypher.match/2","doc":"iex> match(Node.User, as: :user)\n    %{match: %{user: \"User\"}}\n\n    iex> query = match(Node.User, as: :user)\n    iex> match(query, Node.Comment, as: :comment)\n    %{match: %{user: \"User\", comment: \"Comment\"}}","ref":"Ex4j.Cypher.html#match/2-examples"},{"type":"function","title":"Cypher - Ex4j.Cypher.match/2","doc":"MATCH(user:User)\n    MATCH(comment:Comment)","ref":"Ex4j.Cypher.html#match/2-cypher"},{"type":"function","title":"Ex4j.Cypher.match/3","doc":"","ref":"Ex4j.Cypher.html#match/3"},{"type":"function","title":"Ex4j.Cypher.return/3","doc":"Creates a RETURN clause.","ref":"Ex4j.Cypher.html#return/3"},{"type":"function","title":"Parameters - Ex4j.Cypher.return/3","doc":"- query: The previous query\n  - label: The alias of the Node\n  - props: An optional list of properties to return","ref":"Ex4j.Cypher.html#return/3-parameters"},{"type":"function","title":"Examples - Ex4j.Cypher.return/3","doc":"iex> query = match(Node.User, as: :user)\n    iex> return(query, :user)\n    %{return: %{user: []}, match: %{user: \"User\"}}\n\n    iex> query = match(Node.User, as: :user)\n    iex> return(query, :user, [:age, name])\n    %{return: %{user: [:age, :name]}, match: %{user: \"User\"}}\n\n    iex> query = match(Node.User, as: :user)\n    iex> query = match(query, Node.Comment, as: :comment)\n    iex> query = return(query, :user, [:age, :name])\n    iex> return(query, :comment, [:text])\n    %{\n        return: %{user: [:age, :name], comment: [:text]},\n        match: %{user: \"User\", comment: \"Comment\"}\n    }","ref":"Ex4j.Cypher.html#return/3-examples"},{"type":"function","title":"Cypher - Ex4j.Cypher.return/3","doc":"MATCH(user:User)\n    MATCH(comment:Comment)\n    RETURN user, comment\n\n    MATCH(user:User)\n    MATCH(comment:Comment)\n    RETURN user.name, user.age, comment.text","ref":"Ex4j.Cypher.html#return/3-cypher"},{"type":"function","title":"Ex4j.Cypher.run/1","doc":"Build and execute the query.","ref":"Ex4j.Cypher.html#run/1"},{"type":"function","title":"Parameters - Ex4j.Cypher.run/1","doc":"- query: Either the dynamic query or a string cypher query","ref":"Ex4j.Cypher.html#run/1-parameters"},{"type":"function","title":"Examples - Ex4j.Cypher.run/1","doc":"iex> query = match(Node.User, as: :user)\n    iex> query = return(query, :user)\n    iex> run(query)\n    [%{\"user\" => %Node.User{uuid: nil, name: \"Tiago\", age: 38, email: nil}}]\n\n    iex> query = \"\"\"\n                  MATCH (user:User WHERE user.name = 'Tiago')\n                  RETURN user\n                 \"\"\"\n    iex> run(query)\n    [%{\"user\" => %Node.User{uuid: nil, name: \"Tiago\", age: 38, email: nil}}]","ref":"Ex4j.Cypher.html#run/1-examples"},{"type":"function","title":"Ex4j.Cypher.vertex/3","doc":"Creates a VERTEX.","ref":"Ex4j.Cypher.html#vertex/3"},{"type":"function","title":"Parameters - Ex4j.Cypher.vertex/3","doc":"- query: The previous query\n  - module: The name of the Node\n  - as: The alias of the Node","ref":"Ex4j.Cypher.html#vertex/3-parameters"},{"type":"function","title":"Examples - Ex4j.Cypher.vertex/3","doc":"iex> query = match(Node.User, as: :user)\n    iex> query = vertex(query, Node.Comment, as: :comment)\n    iex> query = edge(query, HAS, as: :h, from: :user, to: :comment, type: :any)\n    iex> query = where(query, :user, \"user.name = 'Tiago'\")\n    iex> query = where(query, :comment, \"comment.value IN [1,2,3]\")\n    iex> query = where(query, :h, \"h.total = 10\")\n    iex> return(query, :user)\n    %{\n        match: %{user: \"User\"},\n        where: %{\n          user:  \"user.name = 'Tiago'\",\n          h: \"h.total = 10\",\n          comment: \"comment.value IN [1, 2, 3]\"\n        },\n        edge: %{user: %{module: HAS, type: :any, to: :comment, label: :h}},\n        vertex: %{comment: \"Comment\"},\n        return: %{user: []}\n    }","ref":"Ex4j.Cypher.html#vertex/3-examples"},{"type":"function","title":"Cypher - Ex4j.Cypher.vertex/3","doc":"MATCH (user:User WHERE user.name = 'Tiago')-[h:HAS WHERE h.total = 10]-(comment:Comment WHERE comment.value in [1,2,3])\n    RETURN user","ref":"Ex4j.Cypher.html#vertex/3-cypher"},{"type":"function","title":"Ex4j.Cypher.where/3","doc":"Creates a WHERE clause.","ref":"Ex4j.Cypher.html#where/3"},{"type":"function","title":"Parameters - Ex4j.Cypher.where/3","doc":"- query: The previous query\n  - label: The alias of the Node\n  - rules: The String rules","ref":"Ex4j.Cypher.html#where/3-parameters"},{"type":"function","title":"Examples - Ex4j.Cypher.where/3","doc":"iex> query = match(Node.User, as: :user)\n    iex> where(query, :user, \"user.name = 'Tiago' AND user.age = 38\")\n    %{\n      match: %{user: \"User\"},\n      where: %{user: \"user.name = 'Tiago' AND user.age = 38\"}\n    }\n\n    iex> query = match(Node.User, as: :user)\n    iex> where(query, :user, \"user.name = 'Tiago' OR user.age IN [38]\")\n    %{\n      match: %{user: \"User\"},\n      where: %{user: \"user.name = 'Tiago' OR user.age IN [38]\"}\n    }","ref":"Ex4j.Cypher.html#where/3-examples"},{"type":"function","title":"Cypher - Ex4j.Cypher.where/3","doc":"MATCH(user:User WHERE user.age = 38 AND user.name = 'Tiago')\n    MATCH(user:User WHERE user.name = 'Tiago' OR user.age IN [38])","ref":"Ex4j.Cypher.html#where/3-cypher"},{"type":"module","title":"Ex4j.Node","doc":"Represents a NODE in your Neo4j Database.","ref":"Ex4j.Node.html"},{"type":"module","title":"Examples - Ex4j.Node","doc":"defmodule Node.User do\n      use Ex4j.Node\n\n      graph do\n        field(:name, :string)\n        field(:age, :integer)\n        field(:email, :string)\n      end\n    end","ref":"Ex4j.Node.html#module-examples"},{"type":"macro","title":"Ex4j.Node.graph/1","doc":"A graph macro similar to Ecto Schemas.\n\nhttps://hexdocs.pm/ecto/Ecto.Schema.html","ref":"Ex4j.Node.html#graph/1"},{"type":"macro","title":"Examples - Ex4j.Node.graph/1","doc":"graph do\n      field(:name, :string)\n      field(:age, :integer)\n      field(:email, :string)\n      field(:date, :utc_datetime)\n    end","ref":"Ex4j.Node.html#graph/1-examples"},{"type":"extras","title":"Ex4j","doc":"# Ex4j\n\nThis library combines the power of Ecto with the Bolt protocol provided by [Bolt Sips](https://github.com/florinpatrascu/bolt_sips) :hearts:\n\nYou can use the whole ecto suite you love for validations and structures plus an elegant DSL to retrieve data from Neo4j.\n\nAll `Ex4j.Node` have `Ecto.Schema`, `Ecto.Changeset` and `Ex4j.Cypher` automatically imported for convenience.","ref":"readme.html"},{"type":"extras","title":"Installation - Ex4j","doc":"The package can be installed by adding `ex4j` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex4j, \"~> 0.1.0\"}\n  ]\nend\n```\n\nAdd the connection settings\n\n```elixir\nconfig :ex4j, Bolt,\n  url: \"bolt://localhost:7687\",\n  basic_auth: [username: \"neo4j\", password: \"zEb0zryxK62NNRXKWxJKd7qeEFkO3mLIgcGwuUA4lvg\"],\n  pool_size: 10,\n  ssl: false\n```\n\nThe docs can be found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Ex4j","doc":"All the entities you query must have a schema `Node.` like below associated in your code:\n\n```elixir\ndefmodule Node.User do\n  use Ex4j.Node\n\n  graph do\n    field(:name, :string)\n    field(:age, :integer)\n    field(:email, :string)\n  end\nend\n```\n\n```elixir\ndefmodule Node.Has do\n  use Ex4j.Node\n\n  graph do\n    field(:date, :utc_datetime_usec)\n  end\nend\n```\n\n```elixir\ndefmodule Node.Comment do\n  use Ex4j.Node\n\n  graph do\n    field(:content, :string)\n  end\nend\n```\n\nThe module you intend to use for queries must `use Ex4j.Cypher`: \n\n```elixir\ndefmodule App do\n  use Ex4j.Cypher\n\n  def execute do \n    match(Node.User, as: :u)\n    |> return(:u)\n    |> run()\n  end\nend\n```\n\n```bash\n  iex> App.execute()\n  [\n    %{\"u\" => %Node.User{uuid: nil, name: \"Tiago\", age: 38, email: nil}},\n    %{\"u\" => %Node.User{uuid: nil, name: \"Davi\", age: 35, email: nil}}\n  ]\n```\n\n```elixir\ndefmodule App do\n  use Ex4j.Cypher\n\n  def execute do \n   match(Node.User, as: :u)\n    |> vertex(Node.Comment, as: :c)\n    |> edge(Node.Has, as: :h, from: :u, to: :c, type: :out)\n    |> where(:u, \"u.age IN [35,38] AND u.name CONTAINS 'Ti'\")\n    |> where(:c, \"c.content CONTAINS 'Article'\")\n    |> where(:h, \"h.date > date('2023-12-15')\")\n    |> return(:u)\n    |> return(:c)\n    |> run()\n  end\nend\n```\n\n```bash\n iex> User.execute()\n [\n    %{\n      \"c\" => %Node.Comment{uuid: nil, content: \"Tiago's Comment\"},\n      \"u\" => %Node.User{uuid: nil, name: \"Tiago\", age: 38, email: nil}\n    },\n    %{\n      \"c\" => %Node.Comment{uuid: nil, content: \"Davi's Comment\"},\n      \"u\" => %Node.User{uuid: nil, name: \"Davi\", age: 35, email: nil}\n    }\n ]\n```\n\n```elixir\ndefmodule App do\n  use Ex4j.Cypher\n\n  def execute do \n    match(Node.User, as: :u)\n    |> edge(Node.Has, as: :h, from: :u, to: :c, type: :out)\n    |> vertex(Node.Comment, as: :c)\n    |> return(:h)\n    |> run()\n  end\nend\n```\n\n```bash\n iex> User.execute()\n [\n    %{\"h\" => %Node.Has{uuid: nil, role: \"Tiago's Role\"}},\n    %{\"h\" => %Node.Has{uuid: nil, role: \"Davi's Role\"}}\n ]\n```\n\n\n```elixir\ndefmodule App do\n  use Ex4j.Cypher\n\n  def execute do \n    match(Node.User, as: :u)\n    |> edge(Node.Has, as: :h, from: :u, to: :c, type: :out)\n    |> vertex(Node.Comment, as: :c)\n    |> return(:u, [:name])\n    |> return(:c, [:content])\n    |> run()\n  end\nend\n```\n\n```bash\niex> User.execute()\n[\n  %{\"c\" => %{\"content\" => \"Tiago's Comment\"}, \"u\" => %{\"name\" => \"Tiago\"}},\n  %{\"c\" => %{\"content\" => \"Davi's Comment\"}, \"u\" => %{\"name\" => \"Davi\"}}\n]\n```\n\n\n```elixir\ndefmodule App do\n  use Ex4j.Cypher\n\n  def execute do \n    match(Node.User, as: :u)\n    |> edge(Node.Has, as: :h, from: :u, to: :c, type: :out)\n    |> vertex(Node.Comment, as: :c)\n    |> return(:u, [:name])\n    |> return(:c, [:content])\n    |> cypher()\n  end\nend\n```\n\n```bash\n  iex> User.execute()\n  \"MATCH (u:User)-[h:Has]->(c:Comment)\\nRETURN c.content,u.name\"\n```\n\nYou can always execute a query directly like so: \n\n```elixir\ndefmodule App do\n  use Ex4j.Cypher\n\n  def execute do\n    query = \n    \"\"\"\n      MATCH (n:Comment) \n      RETURN n \n      LIMIT 25\n    \"\"\"\n\n    run(query)\n  end\nend\n```\n\n```bash\n  iex> App.execute()\n  {:ok,\n  %Bolt.Sips.Response{\n   results: [\n     %{\n       \"n\" => %Bolt.Sips.Types.Node{\n         id: 2,\n         properties: %{\"text\" => \"Tiago's Comment\"},\n         labels: [\"Comment\"]\n       }\n     },\n     %{\n       \"n\" => %Bolt.Sips.Types.Node{\n         id: 3,\n         properties: %{\"content\" => \"Davi's Comment\"},\n         labels: [\"Comment\"]\n       }\n     },\n   ],\n   fields: [\"n\"],\n   records: [\n     [\n       %Bolt.Sips.Types.Node{\n         id: 2,\n         properties: %{\"text\" => \"Tiago's Comment\"},\n         labels: [\"Comment\"]\n       }\n     ],\n     [\n       %Bolt.Sips.Types.Node{\n         id: 3,\n         properties: %{\"content\" => \"Davi's Comment\"},\n         labels: [\"Comment\"]\n       }\n     ]\n   ],\n   plan: nil,\n   notifications: [],\n   stats: [],\n   profile: nil,\n   type: \"r\",\n   bookmark: \"FB:kcwQOoduCuitRfejxXkLly0aBBiQ\"\n }}\n```","ref":"readme.html#usage"},{"type":"extras","title":"Plans - Ex4j","doc":"- Add support for migrations \n- Add suport for more Cypher clauses like: CREATE, SKIP","ref":"readme.html#plans"},{"type":"extras","title":"License - Ex4j","doc":"Ex4j source code is released under Apache License 2.0.\n\nCheck [NOTICE](NOTICE) and [LICENSE](LICENSE) files for more information.","ref":"readme.html#license"},{"type":"extras","title":"NOTICE","doc":"LEGAL NOTICE INFORMATION\n------------------------\n\nAll the files in this distribution are copyright to the terms below.\n\n== lib/elixir/src/elixir_parser.erl (generated by build scripts)\n\nCopyright Ericsson AB 1996-2015\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\n    https://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.\n\n== All other files\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\n   https://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"notice.html"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS","ref":"license.html"}],"content_type":"text/markdown"}